<!DOCTYPE html>
<html lang="es">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>VueJS Filtros | Rimorsoft Online</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
      integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u"
      crossorigin="anonymous"
    />
  </head>
  <body>
    <div id="main" class="container">
      <div class="row">
        <div class="col-sm-4">
          <h1>VueJS - Filtros</h1>
          <button
            v-on:click="getUsers"
            class="btn btn-primary"
            v-if="!lists.length"
          >
            Listar
          </button>
          <ul class="list-group" v-else>
            <li class="list-group-item">
              <input
                type="text"
                placeholder="Buscar"
                class="form-control"
                v-model="name"
              />
            </li>
            <li class="list-group-item" v-for="item in searchUser">
              {{ item.name }}
            </li>
          </ul>
        </div>
        <div class="col-sm-8">
          <h1>JSON</h1>
          <pre>
            {{ $data }}
          </pre>
        </div>
      </div>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.19.2/axios.min.js"></script>
    <script type="text/javascript">
      new Vue({
        el: '#main',
        data: {
          lists: [],
          name: '',
        },
        methods: {
          getUsers: function () {
            var urlUsers = 'https://jsonplaceholder.typicode.com/users'
            axios.get(urlUsers).then((response) => {
              this.lists = response.data
            })
          },
        },
        computed: {
          searchUser: function () {
            return this.lists.filter((item) => item.name.includes(this.name))
          },
        },
      })
    </script>
  </body>
</html>
